#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>

#include "ivce_test.h"
#include "ivc_aes.h"
static int rd_test=0;

void listitem() {
	printf("\n");		
	printf("24.  AES company id Check\n");			
	printf("99. Exit Program\n");
	printf("Please enter the choice>> ");
}

void listitem2() {
	printf("\n");		
	printf("24.  AES company id Check\n");			
	printf("99. Exit Program\n");
	printf("Please enter the choice>> ");
}

void listfd() {
	printf("\n");			
	printf(" Select Dev\n");	
	printf(" 1.  ivce-c604-r10 card 0\n");
	printf(" 2.  ivce-c604-r10 card 1\n");
	printf(" 3.  ivce-c604-r20 card 0\n");
	printf(" 4.  ivce-c604-r20 card 1\n");
	printf(" 5.  ivcme-c604 card 0\n");
	printf(" 6.  ivcme-c604 card 1\n");		
}

#define IVCE_C604_R10	1
#define IVCE_C604_R20	2
#define IVCME_C604	3

#include<time.h>

int main( int argc, char * argv[] ) {
	int rand_value=0,ret,board;
	struct aes_info_s aes_info={
		.PublicKey = {0,0,0,0},
		.vid1 = {0,0,0,0},
		.vid2 = {0,0,0,0},	
		.cid = {0,0,0,0},	//test		
		.pass = -1,							
		};		
	unsigned int cmd;
	int fd,mode;

	time_t t;
	srand((unsigned) time(&t));


	if(argc>1) {
		rd_test=1;
	} else {	
		rd_test=0;
	}


	listfd();
	if (scanf("%d",&cmd)==0) {
		scanf("%*[\n]");
		getchar();
	}
		
	switch (cmd) {
		case 1:	
			fd = open("/dev/cx25821-ioctl1", O_RDWR);
			board = IVCE_C604_R10;
			break;
		case 2:	
			fd = open("/dev/cx25821-ioctl2", O_RDWR);
			board = IVCE_C604_R10;			
			break;
		case 3:	
			fd = open("/dev/cx25858-ioctl0", O_RDWR);
			board = IVCE_C604_R20;			
			break;
		case 4:	
			fd = open("/dev/cx25858-ioctl1", O_RDWR);
			board = IVCE_C604_R20;				
			break;
		case 5:	
			fd = open("/dev/cx25858-ioctl0", O_RDWR);
			board = IVCME_C604;				
			break;
		case 6:	
			fd = open("/dev/cx25858-ioctl1", O_RDWR);
			board = IVCME_C604;				
			break;						
		default:
			return -1;					

	}
	if(fd < 0) {
		printf("Can not open dev\n");
		return -1;
	}

	while(1) {
		switch (board) {
		case IVCE_C604_R10:	
		case IVCE_C604_R20:										
			listitem();
			break;
		case IVCME_C604:				
			listitem2();
			break;						
		default:
			return -1;			
		}
			
		if (scanf("%d",&cmd)==0) {
			scanf("%*[\n]");
			getchar();
			continue;
		}

		switch (cmd) {
		//-------------------------------------------------------
		// AES
		//--------------------------------------------------------			
		case 24:
			printf("\n - AES SOFTWARE VERSION=%d",ivcx_aes_version());

			if(board != IVCME_C604) {
				mode = AES_MODE_GET_CID;
				printf("\nplease input company id ****:");

				if (scanf("%d",&cmd)==0) {
					scanf("%*[\n]");
					getchar();
				}
				aes_info.cid[3]=cmd%10;
				cmd/=10;
				aes_info.cid[2]=cmd%10;
				cmd/=10;
				aes_info.cid[1]=cmd%10;
				cmd/=10;
				aes_info.cid[0]=cmd%10;
			
				printf("\n - cid:	%d %d %d %d",aes_info.cid[0],aes_info.cid[1],aes_info.cid[2],aes_info.cid[3]);	

			} else {
				mode = AES_MODE_GET_VID2;
			}					

			rand_value = rand();
			aes_info.PublicKey[0] = rand_value&0xff;
			aes_info.PublicKey[1] = (rand_value>>8)&0xff;
			aes_info.PublicKey[2] = (rand_value>>16)&0xff;
			aes_info.PublicKey[3] = (rand_value>>24)&0xff;			
			rand_value = rand();
			aes_info.vid1[0] = rand_value&0xff;
			aes_info.vid1[1] = (rand_value>>8)&0xff;
			aes_info.vid1[2] = (rand_value>>16)&0xff;
			aes_info.vid1[3] = (rand_value>>24)&0xff;
			rand_value = rand();
			aes_info.vid2[0] = rand_value&0xff;
			aes_info.vid2[1] = (rand_value>>8)&0xff;
			aes_info.vid2[2] = (rand_value>>16)&0xff;
			aes_info.vid2[3] = (rand_value>>24)&0xff;									
			
			printf("\n - PublicKey:	%x %x %x %x",aes_info.PublicKey[0],aes_info.PublicKey[1],aes_info.PublicKey[2],aes_info.PublicKey[3]);
			printf("\n - vid1 :	%x %x %x %x",aes_info.vid1[0],aes_info.vid1[1],aes_info.vid1[2],aes_info.vid1[3]);
			printf("\n - vid2 :	%x %x %x %x",aes_info.vid2[0],aes_info.vid2[1],aes_info.vid2[2],aes_info.vid2[3]);

			ret = ivcx_ap_aes_check(fd,mode,&aes_info);
			
			if(ret==0) {
				if(aes_info.pass == AES_PASS) {
					printf("\n - AES pass %d",aes_info.pass);
				} else {
					printf("\n - AES error %d",aes_info.pass);			
				}
			} else {
				printf("\n - ivcx_ap_aes_check error %d",ret);
			}
			

			break;								
		case 99:
			close(fd);
			exit(0);
			break;
		default:
			break;
		}
	}

	return 0;
}
