#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>

#include "ivce_test.h"
#include "ivc_aes.h"
static int rd_test=0;

void listitem() {
	printf("\n");		
	printf(" 1.  VIOCARD Read\n");
	printf(" 2.  VIOCARD OUT0 High\n");
	printf(" 3.  VIOCARD OUT0 Low\n");
	printf(" 4.  VIOCARD OUT1 High\n");
	printf(" 5.  VIOCARD OUT1 Low\n");
	printf(" 6.  VIOCARD OUT2 High\n");
	printf(" 7.  VIOCARD OUT2 Low\n");
	printf(" 8.  VIOCARD OUT3 High\n");
	printf(" 9.  VIOCARD OUT3 Low\n");				
	printf("10.  SYSTEM RDY LED High\n");
	printf("11.  SYSTEM RDY LED Low\n");	
	printf("12.  SYSTEM ERR LED High\n");
	printf("13.  SYSTEM ERR LED Low\n");
	printf("14.  WDT TOGGLE LED High\n");
	printf("15.  WDT TOGGLE LED Low\n");

	printf("16.  WDT use SoftWare TOGGLE\n");
	printf("20.  WDT start\n");
	if(rd_test) {
	printf("21.  WDT stop\n");
	}
	printf("22.  WDT driver toggle disable (test use ,wait 5 sec,check reset pin)\n");
	if(rd_test) {
	printf("23.  WDT driver toggle enable  (test use)\n");	
	}
	if(rd_test) {	
	printf("25.  GET MCU INFO\n");
	printf("26.  Find other I2C Devices (test use)\n");
	printf("27. VOUT IS NTSC PATTERN(adv7391 color bar)\n");
	printf("28. VOUT IS PAL PATTERN(adv7391 color bar) \n");
	}
	printf("29. VOUT IS NTSC\n");
	printf("30. VOUT IS PAL\n");		
	printf("31. VI1 BYPASS VO1 \n");
	printf("32. VI2 BYPASS VO1 \n");
	printf("33. VI3 BYPASS VO1 \n");
	printf("34. VI4 BYPASS VO1 \n");	
	//printf("35. VI1 BYPASS VO2 \n");
	//printf("36. VI2 BYPASS VO2 \n");	
	//printf("37. VI3 BYPASS VO2 \n");
	//printf("38. VI4 BYPASS VO2 \n");		
					
	printf("99. Exit Program\n");
	printf("Please enter the choice>> ");
}

void listitem2() {
	printf("\n");	
	printf(" 1.  VIOCARD Read\n");
	printf(" 2.  VIOCARD OUT0 High\n");
	printf(" 3.  VIOCARD OUT0 Low\n");
	printf(" 4.  VIOCARD OUT1 High\n");
	printf(" 5.  VIOCARD OUT1 Low\n");
	printf(" 6.  VIOCARD OUT2 High\n");
	printf(" 7.  VIOCARD OUT2 Low\n");
	printf(" 8.  VIOCARD OUT3 High\n");
	printf(" 9.  VIOCARD OUT3 Low\n");
	if(rd_test) {
	printf("25.  GET MCU INFO\n");		
	}			
	printf("99. Exit Program\n");
	printf("Please enter the choice>> ");
}

void listfd() {
	printf("\n");			
	printf(" Select Dev\n");	
	printf(" 1.  ivce-c604-r10 card 0\n");
	printf(" 2.  ivce-c604-r10 card 1\n");
	printf(" 3.  ivce-c604-r20 card 0\n");
	printf(" 4.  ivce-c604-r20 card 1\n");
	printf(" 5.  ivcme-c604 card 0\n");
	printf(" 6.  ivcme-c604 card 1\n");		
}

#define IVCE_C604_R10	1
#define IVCE_C604_R20	2
#define IVCME_C604	3

int main( int argc, char * argv[] ) {
	int i,board;
	struct ivce_gpio_s gpio;
	struct mcu_info_s mcu_info;
		
	unsigned int cmd;
	int fd,num;



	if(argc>1) {
		rd_test=1;
	} else {	
		rd_test=0;
	}


	listfd();
	if (scanf("%d",&cmd)==0) {
		scanf("%*[\n]");
		getchar();
	}
		
	switch (cmd) {
		case 1:	
			fd = open("/dev/cx25821-ioctl1", O_RDWR);
			board = IVCE_C604_R10;
			break;
		case 2:	
			fd = open("/dev/cx25821-ioctl2", O_RDWR);
			board = IVCE_C604_R10;			
			break;
		case 3:	
			fd = open("/dev/cx25858-ioctl0", O_RDWR);
			board = IVCE_C604_R20;			
			break;
		case 4:	
			fd = open("/dev/cx25858-ioctl1", O_RDWR);
			board = IVCE_C604_R20;				
			break;
		case 5:	
			fd = open("/dev/cx25858-ioctl0", O_RDWR);
			board = IVCME_C604;				
			break;
		case 6:	
			fd = open("/dev/cx25858-ioctl1", O_RDWR);
			board = IVCME_C604;				
			break;						
		default:
			return -1;					

	}
	if(fd < 0) {
		printf("Can not open dev\n");
		return -1;
	}

	while(1) {
		switch (board) {
		case IVCE_C604_R10:	
		case IVCE_C604_R20:										
			listitem();
			break;
		case IVCME_C604:				
			listitem2();
			break;						
		default:
			return -1;			
		}
			
		if (scanf("%d",&cmd)==0) {
			scanf("%*[\n]");
			getchar();
			continue;
		}

		switch (cmd) {
		//-------------------------------------------------------
		// GPIO
		//--------------------------------------------------------			

		case 1:	// 1.  VIOCARD Read
			if(board != IVCME_C604) {			
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_4;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_4=%d",gpio.value);
			}

			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_5;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_5=%d",gpio.value);
			}			
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_6;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_6=%d",gpio.value);						
			}
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_7;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_7=%d",gpio.value);	
			}
			} else {

			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_0;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_0=%d",gpio.value);
			}			
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_1;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_1=%d",gpio.value);
			}			
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_2;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_2=%d",gpio.value);						
			}
			gpio.cmd 	= PIO_GET_CMD;
			gpio.num 	= IO_VIO_CARD_3;
			gpio.value 	= 0;
			if(ioctl(fd, IVCE_GPIO, &gpio) == 0) {
				printf("\n IO_VIO_CARD_3=%d",gpio.value);	
			}
			}								
			break;
		case 2:	//2.  VIOCARD OUT0 High
			if(board != IVCME_C604) {
			gpio.num 	= IO_VIO_CARD_0;
			gpio.cmd 	= PIO_SET_CMD;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_0=%d",gpio.value);
			} else {
			gpio.num 	= IO_VIO_CARD_4;
			gpio.cmd 	= PIO_SET_CMD;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_4=%d",gpio.value);
			}
			break;
		case 3: //3.  VIOCARD OUT0 Low
			if(board != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_0;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_0=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_4;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_4=%d",gpio.value);
			}
			break;
		case 4: //4.  VIOCARD OUT1 High
			if(board != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_1;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_1=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_5;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_5=%d",gpio.value);
			}
			break;
		case 5: //5.  VIOCARD OUT1 Low
			if(board != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_1;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_1=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_5;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_5=%d",gpio.value);
			}
			break;
		case 6: //6.  VIOCARD OUT2 High
			if(board != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_2;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_2=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_6;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_6=%d",gpio.value);
			}
			break;
		case 7:
			if(board != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_2;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_2=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_6;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_6=%d",gpio.value);
			}
			break;
		case 8:
			if(board != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_3;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_3=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_7;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_7=%d",gpio.value);
			}
			break;
		case 9:
			if(board != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_3;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_3=%d",gpio.value);
			} else {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_VIO_CARD_7;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_VIO_CARD_7=%d",gpio.value);
			}
			break;			
		case 10:
			if(board != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_SYS_RDY;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_SYS_RDY=%d",gpio.value);
			}
			break;
		case 11:
			if(board != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_SYS_RDY;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_SYS_RDY=%d",gpio.value);
			}
			break;				
		case 12:
			if(board != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_SYS_ERR;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_SYS_ERR=%d",gpio.value);
			}
			break;
		case 13:
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_SYS_ERR;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_SYS_ERR=%d",gpio.value);
			break;
		case 14:
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_WDT_TOG;
			gpio.value 	= 0;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_WDT_TOG=%d",gpio.value);
			break;
		case 15:
			if(board != IVCME_C604) {
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_WDT_TOG;
			gpio.value 	= 1;
			ioctl(fd, IVCE_GPIO, &gpio);
			printf("\n IO_WDT_TOG=%d",gpio.value);
			}
			break;	
		//-------------------------------------------------------
		// WDT
		//--------------------------------------------------------
		case 16:
			if(board != IVCME_C604) {
			cmd = PIO_WDT_EN;
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_EN");
			gpio.cmd 	= PIO_SET_CMD;
			gpio.num 	= IO_WDT_TOG;

			cmd = PIO_WDT_DIS_DRIVER_TOGGLE;		
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_DIS_DRIVER_TOGGLE");
			printf("\n check reset pin\n");			
			for(i=0;i<10;i++) {	//toggle time min 1 sec
				sleep(1);
				gpio.value 	= 0;
				ioctl(fd, IVCE_GPIO, &gpio);
				printf("\n IO_WDT_TOG=%d",gpio.value);
				sleep(1);
				gpio.value 	= 1;
				ioctl(fd, IVCE_GPIO, &gpio);
				printf("\n IO_WDT_TOG=%d",gpio.value);

			}
			printf("\n software not toggle wdt,Wait ...reset\n");
			sleep(10);
			}
			break;

		case 20:
			if(board != IVCME_C604) {
			cmd = PIO_WDT_EN;
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_EN");
			}
			break;
		case 21:
			if(board != IVCME_C604) {
			cmd = PIO_WDT_DIS;		
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_DIS");
			}
			break;				
		case 22:
			if(board != IVCME_C604) {
			cmd = PIO_WDT_DIS_DRIVER_TOGGLE;		
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_DIS_DRIVER_TOGGLE");
			}
			break;
		case 23:
			if(board != IVCME_C604) {
			cmd = PIO_WDT_EN_DRIVER_TOGGLE;		
			ioctl(fd, IVCE_WDT, &cmd);
			printf("\n PIO_WDT_EN_DRIVER_TOGGLE");
			}
			break;

		//-------------------------------------------------------
		// OTHER
		//--------------------------------------------------------																						
		case 25:
			memset(&mcu_info,0x0,sizeof(struct mcu_info_s));
			printf("cmd = 0x%x\n",IVCE_GET_MCU_INFO);					
			ioctl(fd, IVCE_GET_MCU_INFO, &mcu_info);

			printf("version = %d\n",mcu_info.version);
			printf("reversion = %d\n",mcu_info.reversion);	
			if(board != IVCME_C604) {			
				printf("board_id = %d\n",mcu_info.board_id);
				printf("card_id = %d\n",mcu_info.card_id);	
			}
					
			break;	
		case 26:
			if(board != IVCME_C604) {		
			ioctl(fd, IVCE_POLL_I2C, &num);			
			printf("find %d i2c devices\n",num);	
			}		
			break;	
		//-------------------------------------------------------
		// VOUT
		//--------------------------------------------------------		
		case 27:
			cmd = STD_NTSC;		
			ioctl(fd, ATLAS_IOCTL_SET_VID_STD, &cmd);
			printf("\n IVCE_VOUT_FORMAT %d",cmd);			
			cmd = VOUT_NTSC_PATTERN;		
			goto set_vout_format;
		case 28:
			cmd = STD_PAL;
			ioctl(fd, ATLAS_IOCTL_SET_VID_STD, &cmd);
			printf("\n IVCE_VOUT_FORMAT %d",cmd);										
			cmd = VOUT_PAL_PATTERN;
			goto set_vout_format;						
		case 29:
			cmd = STD_NTSC;		
			ioctl(fd, ATLAS_IOCTL_SET_VID_STD, &cmd);
			printf("\n IVCE_VOUT_FORMAT %d",cmd);			
			cmd = VOUT_NTSC;		
			goto set_vout_format;
		case 30:
			cmd = STD_PAL;
			ioctl(fd, ATLAS_IOCTL_SET_VID_STD, &cmd);
			printf("\n IVCE_VOUT_FORMAT %d",cmd);									
			cmd = VOUT_PAL;
		set_vout_format:			
			ioctl(fd, IVCE_VOUT_FORMAT, &cmd);
			printf("\n IVCE_VOUT_FORMAT %d",cmd);	
			break;				
		case 31:
		case 32:
		case 33:
		case 34:						
			cmd -= 31;	//ch0~3 cmd=0~3		
			ioctl(fd, IVCE_BYPASS_VOUT1, &cmd);
			printf("\n IVCE_BYPASS_VOUT1 CH%d",cmd);
			break;						
		case 35:
		case 36:
		case 37:
		case 38:						
			cmd -= 35;	//ch0~3 cmd=0~3			
			ioctl(fd, IVCE_BYPASS_VOUT2, &cmd);
			printf("\n IVCE_BYPASS_VOUT2 CH%d",cmd);
			break;

		case 40:
			cmd = STD_NTSC;		
			ioctl(fd, ATLAS_IOCTL_SET_VID_STD, &cmd);
			printf("\n IVCE_VOUT_FORMAT %d",cmd);
			break;	
		case 41:		
			cmd = VOUT_NTSC;		
			goto set_vout_format;

									
		case 99:
			close(fd);
			exit(0);
			break;
		default:
			break;
		}
	}

	return 0;
}
