#ifndef _GPIO_H_
#define _GPIO_H_


#define ATLAS_IOCTL_MAGIC                'a'
#define ATLAS_IOCTL_SET_4D1_INTERLEAVE    _IO(ATLAS_IOCTL_MAGIC, 1)
#define ATLAS_IOCTL_SET_VID_STD           _IOW(ATLAS_IOCTL_MAGIC, 2, int)
#define STD_NTSC 525
#define STD_PAL 625

#define ATLAS_IOCTL_SET_8D1_INTERLEAVE    _IO(ATLAS_IOCTL_MAGIC, 3)



/* Use 'i' as magic number */
#define IOC_MAGIC       'i'
#define IOC_MAGIC_OFFSET	0      
//GPIO
#define IVCE_GPIO			_IOW(IOC_MAGIC, 0x00+IOC_MAGIC_OFFSET, struct ivce_gpio_s)
	struct ivce_gpio_s{
		unsigned int cmd;		//		 
		unsigned int num;		//
		unsigned int value;		//	 
	};
	//cmd
	#define PIO_GET_CMD	1
	#define PIO_SET_CMD	2

	//num
	#define IO_VIO_CARD_0	0
	#define IO_VIO_CARD_1 	1
	#define IO_VIO_CARD_2 	2
	#define IO_VIO_CARD_3 	3
	#define IO_VIO_CARD_4 	4
	#define IO_VIO_CARD_5 	5
	#define IO_VIO_CARD_6 	6
	#define IO_VIO_CARD_7	7
	#define IO_SYS_ERR	8
	#define IO_SYS_RDY	9
	#define IO_WDT_TOG 	10
	#define IO_BH1_DET 	11
	#define IO_9		12
	#define IO_10 		13
	#define IO_11		14
	#define IO_12		15
	#define IO_13		16
	#define IO_14 		17 
	#define IO_15 		18 	     
//WDT
#define IVCE_WDT			_IOW(IOC_MAGIC, 0x01+IOC_MAGIC_OFFSET, int)

#define PIO_WDT_EN			1
#define PIO_WDT_DIS			2
#define PIO_WDT_EN_DRIVER_TOGGLE	98	//test
#define PIO_WDT_DIS_DRIVER_TOGGLE	99	//test

//MCU
struct mcu_info_s {
	unsigned char version;
	unsigned char reversion;
	unsigned char card_id;
	unsigned char board_id;	
	//unsigned char bar_code1[11];	//not use		
	//unsigned char bar_code2[11];	//not use	 		
};



#define IVCE_GET_MCU_INFO		_IOR(IOC_MAGIC, 0x02+IOC_MAGIC_OFFSET, struct mcu_info_s)

#define IVCE_POLL_I2C			_IOR(IOC_MAGIC, 0x03+IOC_MAGIC_OFFSET, int)

//AES
struct aes_info_s {
	unsigned char PublicKey[4];
	unsigned char vid1[4];		
	unsigned char vid2[4];		
	unsigned char cid[4];
	int pass;				 		
};

#define AES_PASS	(0)
#define AES_ERR		(-1)

#define IVCE_AES			_IOW(IOC_MAGIC, 0x04+IOC_MAGIC_OFFSET, struct aes_info_s)	

#define IVCE_BYPASS_VOUT1		_IOW(IOC_MAGIC, 0x05+IOC_MAGIC_OFFSET, int)

#define IVCE_BYPASS_VOUT2		_IOW(IOC_MAGIC, 0x06+IOC_MAGIC_OFFSET, int)

#define IVCE_VOUT_FORMAT		_IOW(IOC_MAGIC, 0x07+IOC_MAGIC_OFFSET, int)
	#define VOUT_NTSC	0
	#define VOUT_PAL	1
	#define VOUT_NTSC_PATTERN	2
	#define VOUT_PAL_PATTERN	3
	
#endif //_GPIO_H_
